/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageReaction type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageReaction{}

// MessageReaction struct for MessageReaction
type MessageReaction struct {
	Emoji *string `json:"emoji,omitempty"`
	MessageId *string `json:"message_id,omitempty"`
	Deleted *bool `json:"deleted,omitempty"`
}

// NewMessageReaction instantiates a new MessageReaction object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageReaction() *MessageReaction {
	this := MessageReaction{}
	return &this
}

// NewMessageReactionWithDefaults instantiates a new MessageReaction object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageReactionWithDefaults() *MessageReaction {
	this := MessageReaction{}
	return &this
}

// GetEmoji returns the Emoji field value if set, zero value otherwise.
func (o *MessageReaction) GetEmoji() string {
	if o == nil || IsNil(o.Emoji) {
		var ret string
		return ret
	}
	return *o.Emoji
}

// GetEmojiOk returns a tuple with the Emoji field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageReaction) GetEmojiOk() (*string, bool) {
	if o == nil || IsNil(o.Emoji) {
		return nil, false
	}
	return o.Emoji, true
}

// HasEmoji returns a boolean if a field has been set.
func (o *MessageReaction) HasEmoji() bool {
	if o != nil && !IsNil(o.Emoji) {
		return true
	}

	return false
}

// SetEmoji gets a reference to the given string and assigns it to the Emoji field.
func (o *MessageReaction) SetEmoji(v string) {
	o.Emoji = &v
}

// GetMessageId returns the MessageId field value if set, zero value otherwise.
func (o *MessageReaction) GetMessageId() string {
	if o == nil || IsNil(o.MessageId) {
		var ret string
		return ret
	}
	return *o.MessageId
}

// GetMessageIdOk returns a tuple with the MessageId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageReaction) GetMessageIdOk() (*string, bool) {
	if o == nil || IsNil(o.MessageId) {
		return nil, false
	}
	return o.MessageId, true
}

// HasMessageId returns a boolean if a field has been set.
func (o *MessageReaction) HasMessageId() bool {
	if o != nil && !IsNil(o.MessageId) {
		return true
	}

	return false
}

// SetMessageId gets a reference to the given string and assigns it to the MessageId field.
func (o *MessageReaction) SetMessageId(v string) {
	o.MessageId = &v
}

// GetDeleted returns the Deleted field value if set, zero value otherwise.
func (o *MessageReaction) GetDeleted() bool {
	if o == nil || IsNil(o.Deleted) {
		var ret bool
		return ret
	}
	return *o.Deleted
}

// GetDeletedOk returns a tuple with the Deleted field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageReaction) GetDeletedOk() (*bool, bool) {
	if o == nil || IsNil(o.Deleted) {
		return nil, false
	}
	return o.Deleted, true
}

// HasDeleted returns a boolean if a field has been set.
func (o *MessageReaction) HasDeleted() bool {
	if o != nil && !IsNil(o.Deleted) {
		return true
	}

	return false
}

// SetDeleted gets a reference to the given bool and assigns it to the Deleted field.
func (o *MessageReaction) SetDeleted(v bool) {
	o.Deleted = &v
}

func (o MessageReaction) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageReaction) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Emoji) {
		toSerialize["emoji"] = o.Emoji
	}
	if !IsNil(o.MessageId) {
		toSerialize["message_id"] = o.MessageId
	}
	if !IsNil(o.Deleted) {
		toSerialize["deleted"] = o.Deleted
	}
	return toSerialize, nil
}

type NullableMessageReaction struct {
	value *MessageReaction
	isSet bool
}

func (v NullableMessageReaction) Get() *MessageReaction {
	return v.value
}

func (v *NullableMessageReaction) Set(val *MessageReaction) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageReaction) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageReaction) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageReaction(val *MessageReaction) *NullableMessageReaction {
	return &NullableMessageReaction{value: val, isSet: true}
}

func (v NullableMessageReaction) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageReaction) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


